#ifndef _beam_h_
#define _beam_h_
#include "EnergyProfile.h"
#include "params.h"
#include "particle.h"

/// The beam shoots with identical particles (whose energy is defined by some 
/// energy profile but the direction of momentum is identical)
/// beam: this class provides the input of the initial beam particle 
/// into the generator.The beam particle is defined by providing 
/// its energy, direction and its PDG code to the constructor
/// of the beam class 

class beam
{
   EnergyProfile g;
   vec dir;
   int pdg;
   double mass;
public:   
   beam(params& p):g(p.beam_energy),dir(p.beam_direction.dir()),pdg(p.beam_particle), mass(PDG::mass(p.beam_particle))
   {}
   /// get next particle form the beam
   particle shoot()
   { particle p(pdg,mass);
     p.set_momentum(dir);
     p.set_energy(g.shoot());
     return p;
   }
};
#endif
