#ifndef _chooser_h_
#define _chooser_h_

#include "params.h"

template <int N> 
class chooser
{ 
    double _Max;
    double _sum[N];
    double _max[N];
    int    _count[N];
    double _dist[N+1];   
    //bool   on[N];
    
 public:
    chooser(params &p)
    {for(int i=0;i<N;i++)
        {_dist[i]=i;
	 //on[i]=1;
	 _sum[i]=0;
	 _count[i]=0;
	 _max[i]=0;
	} 
     _dist[N]=N; 
   }
    
    void add(int proc,double probab)
    {_count[proc]++;
     _sum[proc]+=probab;
     if(probab>_max[proc])
        {_max[proc]=probab;
	 if(probab>_Max)
	   _Max=probab;
	}   
    }
    
    int choose()//wybiera dynamike
    {
       double x=frandom()*_dist[N];
       int i=N;
       while(x<_dist[--i]);
         
       return i;      
    }

    void update_weights_avg()
    {
      _dist[0]=0;
    cout<<"Updating"<<endl;
     for(int i=0;i<N;i++)
        {
        if(_count[i]==0)
	  _count[i]=1;
        _dist[i+1]=_dist[i]+avg(i);// accumulating mean values
        _sum[i]=_count[i]=0; // empty the bin 
	}
     _Max=0;	
     for(int i=0;i<N;i++)
        { if(_max[i]>0)
       	  _max[i]/=ratio(i);
	 if(_max[i]>_Max)
          _Max=_max[i];    
     	}
    }

    void update_weights_max()
    {
    cout<<"Updating"<<endl;
     for(int i=0;i<N;i++)
        {
        if(_count[i]==0)
	  _count[i]=1;
        // cout<<"srednia["<<i<<"]="<<sum[i]/count[i]<<'\t'<< "max="<< max[i] <<endl;
        _dist[i+1]=_dist[i]+_max[i];
        _sum[i]=_count[i]=0;
	}
     _Max=0;	
     for(int i=0;i<N;i++)
        { if(_max[i]>0)
       	  _max[i]/=ratio(i);
	 if(max[i]>_Max)
          _Max=_max[i];    
     	}
    }
    
    double weight(int i)//odleglosci
    {
       return _dist[i+1]-_dist[i];
    }

    double count(int i)
    {
       return _count[i];
    }

    double ratio(int i)/// probability of choosing i-th bin
    {
       return weight(i)/_dist[N];
    }
    double Max()
    { 
       return _Max;
    }
    double avg (int i)
    {
      if(_count[i]==0)
	return 0;
      return _sum[i]/_count[i];
    }
    double max (int i)
    {
	return _max[i];
    }
};
#endif
