#include <cassert>      //what is this?
#include "particle.h"
#include "jednostki.h"
#include <fstream>
#include <sstream>
#include <cmath>
#include "params.h"
#include "beam.h"
#include "pdg.h"
#include "target.h"
#include "cohdynamics.h"
#include "event1.h"
#include "cohevent.h"
//#include "wrodef.h"


//	Coherent single pion production
//	Implementation of the Rein-Sehgal model
//	Nucl. Phys. B 


extern double cohQ2;
extern double cohleptonmom_x;
extern double cohleptonmom_y;
extern double cohleptonmom_z;
extern double cohlepton_t;
extern double cohpionmom_x;
extern double cohpionmom_y;
extern double cohpionmom_z;
extern double cohpion_en;


////////////////////////////////////////////////////////////////////////
double cohevent(params &p, event &e, target &t, bool cc)
////////////////////////////////////////////////////////////////////////
{
e.par=p;
e.flag.coh=true;
e.flag.cc=cc;
e.flag.nc=!cc;
e.flag.dis=false;
e.flag.qel=false;

e.weight=0;


//	Initial neutrino
particle cohnu=e.in[0];

//	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//	It is necessary to describe e.in[1] as a nucleus with some pdg number etc

//	Final lepton; neutrino for nc and charged lepton for cc
particle cohlepton;

//	Final pion
particle cohN1;

//	Identification of final states
//	In NC reaction always pi0 is produced
//	In CC neutrino reaction pi+ is produced and in antineutrino reaction pi- is produced


    if(!cc)
    {cohlepton=cohnu;
     cohN1.pdg=111;}
    else 
     if(cohnu.pdg>0)
	{cohlepton.pdg=cohnu.pdg-1;
	cohN1.pdg=211;}
	else
	    {cohlepton.pdg=cohnu.pdg+1;
	     cohN1.pdg=-211;}

//	Setting final particles masses
cohlepton.set_mass(PDG::mass(cohlepton.pdg));
cohN1.set_mass(PDG::mass(cohN1.pdg));

double wynik=cohwaga (cohnu.t, cc, p.coh_mass_correction);

e.weight=wynik;
//cout<<wynik<<endl;

vec cohleptmom = vec (cohleptonmom_x, cohleptonmom_y, cohleptonmom_z);
vec cohpionmom = vec (cohpionmom_x, cohpionmom_y, cohpionmom_z);
//cout<<"ped_x="<<cohleptonmom_x<<"   wynik="<<endl;
cohlepton.set_momentum(cohleptmom);
cohN1.set_momentum(cohpionmom);

/*
cohlepton.x=cohleptonmom_x;
cohlepton.y=cohleptonmom_y; 
cohlepton.z=cohleptonmom_z;
cohlepton.t=cohlepton_t;
cohN1.x=cohpionmom_x;
cohN1.y=cohpionmom_y;
cohN1.z=cohpionmom_z; 
cohN1.t=cohpion_en;
*/

//e.flag.q2=cohQ2;
//e.flag.W=cohN1.mass();

e.temp.push_back(cohlepton);
e.temp.push_back(cohN1);
e.out.push_back(cohlepton);
e.out.push_back(cohN1);

return wynik;

}

