#include <cassert>
#include "particle.h"
#include "jednostki.h"
#include <fstream>
#include <sstream>
#include <cmath>
#include "params.h"
#include "beam.h"
#include "pdg.h"
#include "target.h"
#include "cohdynamics2.h"
#include "event1.h"

//      Coherent single pion production
//      Implementation of the Rein-Sehgal model
//      Nucl. Phys. B 

//extern double cohQ2;
extern vec cohlepton3mom;
extern vec cohpion3mom;

extern double cohx, cohy, cohz, cohphi;
double cohm;

/*extern double cohleptonmom_x;
extern double cohleptonmom_y;
extern double cohleptonmom_z;
extern double cohlepton_t;
extern double cohpionmom_x;
extern double cohpionmom_y;
extern double cohpionmom_z;
extern double cohpion_en;*/

////////////////////////////////////////////////////////////////////////
void
cohevent2 (params & p, event & e, target & t, bool cc)
////////////////////////////////////////////////////////////////////////
{
  e.par = p;
  e.flag.coh = true;
  e.flag.cc = cc;
  e.flag.nc = !cc;
  e.flag.dis = false;
  e.flag.qel = false;

/*e.flag.xx=cohx;
e.flag.yy=cohy;
e.flag.zz=cohz;
e.flag.phiphi=cohphi;
*/
  target jadro (p);
  int cohA = jadro.p + jadro.n;


//      Initial neutrino
  particle cohnu = e.in[0];

//      Final lepton; neutrino for nc and charged lepton for cc
  particle cohlepton;

//      Final pion
  particle cohpion;

//      Identification of final states
//      In NC reaction always pi0 is produced
//      In CC neutrino reaction pi+ is produced and in antineutrino reaction pi- is produced

  if (!cc)
    {
      cohlepton = cohnu;
      cohpion.pdg = 111;
    }
  else if (cohnu.pdg > 0)
    {
      cohlepton.pdg = cohnu.pdg - 1;
      cohpion.pdg = 211;
    }
  else
    {
      cohlepton.pdg = cohnu.pdg + 1;
      cohpion.pdg = -211;
    }

//      Setting final particles masses
  cohlepton.set_mass (PDG::mass (cohlepton.pdg));
  cohpion.set_mass (PDG::mass (cohpion.pdg));

  double cohm = cohlepton.mass ();
  double wynik = cohwaga2 (cohnu.t, cc, cohA, p.coh_mass_correction, cohm);	//weight
//cout<<cohnu.t<<" "<<cc<<" "<<cohA<<" "<<p.coh_mass_correction<<"  "<<cohm<<" "<<wynik<<endl;
  e.weight = wynik;

//vec cohleptmom = vec (cohleptonmom_x, cohleptonmom_y, cohleptonmom_z);
//vec cohpionmom = vec (cohpionmom_x, cohpionmom_y, cohpionmom_z);

  cohlepton.set_momentum (cohlepton3mom);
  cohpion.set_momentum (cohpion3mom);

//e.temp.push_back(cohlepton);
//e.temp.push_back(cohN1);
  e.out.push_back (cohlepton);
  e.out.push_back (cohpion);
//return wynik;
}
