#ifndef __LOCALKF__
#define __LOCALKF__
#include <cmath>
#include <fstream>
#include <sstream>
#include "generatormt.h"
//fermi momentum distribution for Argon
///////////////////////////////////////////////////////////////////////
double localkf_Ar (double kf)
///////////////////////////////////////////////////////////////////////
{
  
  double r, pr;
  double C=3.530;
  double C1=0.541;
  double rho0=0.176;
  double z=0;

  do
    {
      r =  frandom_sqr() * 15;
      z=(r-C)/C1;
      pr = rho0*(1./(1+exp(z)));
	
    }
  while (pr < frandom ()*0.2);

  double result = pow(3*M_PI*M_PI*pr/2,1./3.)*197.4;
 // cout<<"tu argon"<<endl;
  return result;
}

//fermi momentum distribution for Iron
///////////////////////////////////////////////////////////////////////
double localkf_Fe (double kf)
///////////////////////////////////////////////////////////////////////
{
  
  double r, pr;
  double C=4.111;
  double C1=0.558;
  double rho0=0.163;
  double z=0;

  do
    {
      r = frandom_sqr () * 15;
      z=(r-C)/C1;
      pr = rho0*(1./(1+exp(z)));
	
    }
  while (pr < frandom ()*0.2);

  double result = pow(3*M_PI*M_PI*pr/2,1./3.)*197.4;
  return result;
}

//fermi momentum distribution for oxygen
///////////////////////////////////////////////////////////////////////
double localkf_O (double kf)
///////////////////////////////////////////////////////////////////////
{

  double r, pr;
  double C=1.544;
  double rho0=0.141;
  double R_O=1.833;    
  do
    {
      r = frandom_sqr () * 10;
      r = r/R_O;
      pr =	rho0*exp(-r*r)*(1+C*r*r);
	
    }
  while (pr < frandom ()*0.2);
  
  double result = pow(3*M_PI*M_PI*pr/2.,1./3.)*197.4;
  return result;
}
#endif
