#include "kinsolver.h"
#include <cassert>          
#include "particle.h"
#include "qelcc.h"
#include "qelnc.h"
#include "jednostki.h"
#include <fstream>
#include <sstream>
#include "localkf.h"
#include <cmath>
#include "params.h"
#include "qelevent.h"
#include "beam.h"
#include "kinematics.h"
#include "pdg.h"
#include "target.h"
#include "dis/LeptonMass.h"
#include <cstdlib>
#define LOCALKF localkf_O

//double qelm;

////////////////////////////////////////////////////////////////////////
double qelevent(params&p, event & e, target &t,bool nc)
////////////////////////////////////////////////////////////////////////
  { //cout<<"jestem w qelevent"<<endl;
    e.par=p;
    e.flag.qel=true;
    e.flag.nc=nc;
    e.flag.cc=!nc;
    e.flag.dis=false;
    e.weight=0;

    particle nu=e.in[0];		           // neutrino
    particle N0=e.in[1];		           // initial nucleon
    particle lepton;  
    particle N1;

    if(nc)
    {lepton=nu;
     N1=N0;
     }
     else 
     if((nu.pdg>0 && N0.pdg==PDG::pdg_proton) ||( nu.pdg<0 && N0.pdg==PDG::pdg_neutron))
       return 0;
     else  
     { lepton.pdg=nu.pdg-(nu.pdg>0 ? 1 :-1);
       lepton.set_mass(PDG::mass(lepton.pdg));
       N1.pdg=(nu.pdg>0 ? PDG::pdg_proton : PDG::pdg_neutron);//zmiana JN
       N1.set_mass(PDG::mass(N1.pdg));
     } 
double qelmlep=lepton.mass();
    //cout<<"masa leptonu= "<<lepton.mass()<<endl;

double _E_bind=0;	//binding energy

vec ped=N0.p();

int wybor=p.nucleus_target;

	switch(wybor)
	{
	case 0: _E_bind=0;
	break;
	case 1: _E_bind= p.nucleus_E_b;
	break;
	case 2: _E_bind=0;//temporary
	break;
	case 3: _E_bind=0;//temporary
	break;
	case 4: _E_bind = binen (ped);//SF
	break;
	case 5: _E_bind= deuter_binen (ped);//deuterium 
	break;
	case 6: _E_bind= p.nucleus_E_b;//deuterium like Fermi gas
	break;
	
//in the future it is possible to add SF for other nuclei as well
	default: _E_bind=0;
	}

vect aa;
aa = vect (N0);
aa.t-=_E_bind;
double dlu=sqrt( (aa + vect(nu))*(aa+vect(nu)) );
if (dlu<= (lepton.mass() + N1.mass() ) )
{e.weight=0;
return 0;}


int qel_cc_japan=0;
//cout<<"jestem przed deklaracja z1 z2"<<endl;
    CC _z1(lepton.mass(),lepton.charge(),qel_cc_japan,p.qel_cc_axial_mass*MeV,(PDG::mass_proton+PDG::mass_neutron)/2);
       _z1.set_axial_mass (p.qel_cc_axial_mass*MeV);
    NC _z2;   
       _z2.set_axial_mass (p.qel_nc_axial_mass*MeV);
       
       if(nu.pdg>0) _z2.znak=1;
       else _z2.znak=-1;
       if(N0.pdg==PDG::pdg_proton) 
         {_z2.nukleon=_z2.proton;
	  _z2.set_hadron_mass(PDG::mass_proton);
	 } 
       else 
         {_z2.nukleon=_z2.neutron;
	  _z2.set_hadron_mass(PDG::mass_neutron);
	 } 

//cout<<"nukleon="<<z2.nukleon<<endl; 
//cin.get();
       
       
    if (qel_cc_japan)
	_z1.use_lambda ();
    else
	_z1.dont_use_lambda ();

      
    // cross section (is 0 until the reaction occurs)   
    double x = 0;		
    
    // select fermi momentum: global or local   
    // do the kinematics 
    // calculate q2 and the jakobian of q2 wrt spatial angle in cms
    // 
    double q2,jakobian;  
int qel_kinematics=0;
//cout<<"jestem przed switch qel-kinematics"<<endl;
    switch(qel_kinematics)
    { 
    case  0:   // Subtract the binding energy from the nucleon energy
		//cout<<"jestem w switch qel-kinematics"<<endl;
                q2 = czarek_kinematics(_E_bind, nu, N0, lepton, N1,jakobian);
		//cout<<"Q2=  "<<-q2<<endl;
                break;
		
    case  1:   // preservation of energy momentum for the whole system 
                // the nucleon is off shell 
		// binding energy used for spectator nucleus mass calculation
                q2 = bodek_kinematics (_E_bind, nu, N0, lepton, N1,jakobian);
 	        break;
    case  2:  // effective mass trick kinematics the most doubtful    
               // first lower the nucleon mass down the binging energy
	        N0.set_mass(M12-27*MeV);  
		// next do the usual kinematics 
		// preserving energy and momentum
		// (not taking into account the spactator nucleus)
                q2 = czarek_kinematics(_E_bind  //chyba powinno by�0 bo ju odj�e
		                      , nu, N0, lepton, N1, jakobian);		
	         
		 // use this mass also for dynamics????
		 // should it appear in the form factors
                  _z1.set_hadron_mass(N0.mass()); 
		 break;
    case  3:    // use momentum dependent potential V(p)
                 // V(p) is on both sides of the equation but with different p
//                N1.set_energy(N1.energy()+V(N1.momentum(),kF_P));
                 q2=momentum_dependent_potential_kinematics(nu,N0,lepton,N1,jakobian);
                 break;	       	  
    case  4:    // use momentum dependent potential V(p)
                 // V(p) is on both sides of the equation but with different p
	         // then adjust the kinetic energy 
                 q2=momentum_dependent_potential_kinematics(nu,N0,lepton,N1,jakobian);
	         N1.set_energy(N1.energy()+V(N1.momentum(),t.localkf(N1)));
                 break;	       	  
    default: 
                 cerr<<"Kinematics code: '"<<qel_kinematics<<"' is invalid."<<endl;	  
	         exit(1);
    }  
//    cout<<"q2="<<q2<<endl;
    /* TA CZESC BYLA OK , ZROBIAONA PRZEZ CZARKA
    if (q2 != 0  		   // there was scattering
        &&                         // and
        N1.momentum () >= kF   // Pauli-blocking did not occur	        )
       )
*/
    //!!!!!!!!ZMIANA JARKA PED FERMIEGO
    //e.flag.q2=q2;
    //e.flag.W=N1.mass();
    if (q2 != 0  		   // there was scattering
//        &&                         // and
//        !t.pauli_blocking(N1)   // Pauli-blocking did not occur	        )
       )

    { switch(qel_kinematics)
      {
      case 3: 
      
      N1.set_energy(N1.energy()+V(N1.momentum(),t.localkf(N1)));
      }
}//modyfikacjaaa
      vect v = nu;
      v.boost (-N0.speed ());

//cout<<nc<<endl;

     if(nc)
        {_z2.set_energy (v.t);
         x=_z2.sigma (q2) *jakobian;
	//cout<<"jestem w NC"<<endl;
	} 
     else
        {_z1.set_energy (v.t);
         x=_z1.sigma (q2) *jakobian;
	//cout<<"jestem w CC; Xsec to iloczyn "<<_z1.sigma (q2)<<" oraz "<<jakobian<<endl;
	//cout<<x<<endl;
        }
//    cout<<"x="<<x<<endl;
	
     double vv,vx;
     // now take into account the neutrino flux and nucleon proper time 
     // corrections to the cross section on the whole nucleus
int qel_relat=0;
     switch(qel_relat)
     {
        case 0: // fully relativistic correction as calculated by CJ
	        vv = N0.speed ().length ();
	        vx = N0.speed ().x;
	        x *= sqrt ((1 - vx) * (1 - vx) - vv + vv / 1);
	        break;
        case 1:  // only the flux correction calculated by JS 
	          // classical
                x *= (N0.speed()-nu.speed()).length()  
	             /  nu.speed().length();
		      
	        break;
        case 2: //no correction at all (stupid but simple) 
	        // I think most codes don't do any corrections
	        break;	 
	default:
	        cerr << "flux correction code ="<<qel_relat<<" invalid"<<endl; 
	        exit(1);
      }  
     //}modyfikacjaaa
     e.temp.push_back(lepton);
     e.temp.push_back(N1);
     e.out.push_back(lepton);
     e.out.push_back(N1);
     e.weight=x/cm2;

//cout<<"kFP="<<kF_P<<endl;

//cout<<"CR="<<e.weight<<endl;
//     cout<<(e.flag.nc ? "nc " : "cc " )<<x/cm2<<endl;
     return x;
  }

