#include "qelnc.h"
#include "masses.h"

using namespace std;

//    ----------------------------------------------------------------------
// kind = "+p"  - neutrino proton
// kind = "-p" - antineutrino proton
// kind = "+n"  - neutrino neutron
// kind = "-n" - antineutrino neutron
 
NC::NC(double E,char nucl, char sig ,double mag):En(E),magneton_s(mag)
  {
   magneton_s=mag;
   ro_s= 0.51 -2.9*magneton_s;  // ad hoc by Krzys
   M=M12;
   M2=M12*M12;
   MA=1030*MeV        ;
   MA_2=MA*MA         ;
   switch(sig)
   {case '+': znak=neutrino;break;
    case '-': znak=antyneutrino;break;
    default: throw ("wrong neutrino kode for NC");
    }
   switch(nucl)
   {case 'p': nukleon=proton;break;
    case 'n': nukleon=neutron;break;
    default: throw ("wrong neutrino kode for NC");
    }
   
  }

double NC::amplituda(double q0, double qv)
//double NC::sigma(q2)
{ 

//double magneton =  4.71   ;
double sin2thetaw = 0.232  ;
//const static double M12_2=M12*M12;
int proton  = 1;
int neutron = -1;  // bylo -1 Czarek
int neutrino =1;
int antyneutrino = -1;
double lp = 1.793;
double ln= -1.913;

//double Q2=-q2;
double Q2 = qv*qv-q0*q0;
double M=M12;
double MM=M*M;
////////////////////////////////////////////////////////////////////////////
double Mv2=0.71*GeV2;
double g_a=1.267;
const double sin_2_theta_W = 0.23120;
double Ma=1.03*GeV;
double Ma2=Ma*Ma;

double Ge=1.0/pow(1+Q2/Mv2,2.0);
double Gm=4.71*Ge;

//nowe; BBBA05^
double tau=Q2/4.0/MM;
double tau2=tau*tau;
double tau3=tau*tau2;
double tau4=tau2*tau2;

double Gep=(1-0.0577*tau)/(1+11.2*tau+13.6*tau2+33*tau3);
double Gmp=2.79*(1+0.15*tau)/(1+11.1*tau+19.6*tau2+7.54*tau3);
double Gen=(1.38*tau-0.214*tau2)/(1+8.51*tau+59.9*tau2+13.6*tau3+2.57*tau4);
double Gmn=-1.91*(1+1.82*tau)/(1+14.1*tau+20.7*tau2+69.7*tau3);


double Ge_B=Gep-Gen;
double Gm_B=Gmp-Gmn;


double Fa=-g_a/pow(1+Q2/Ma2,2.0);
double Fp=0;
double F2=(Gm-Ge)/(1+tau);
double F2p=(Gmp-Gep)/(1+tau);
double F2n=(Gmn-Gen)/(1+tau);

double F1=(Ge+Gm*tau)/(1+tau);
double F1p=(Gep+Gmp*tau)/(1+tau);
double F1n=(Gen+Gmn*tau)/(1+tau);

///////form faktory neutralne^
double MV2_NC = 0.843*0.843*GeV2;

//Trzy parametryzacje form faktorw dziwnych my korzystamy z pierwszej^
double F1s_0 = 0.53;
double F2s_0 = -0.40;
double delta_s = -0.21;
Ma =1.012*GeV;
Ma2=Ma*Ma;


double F1s= F1s_0/(1+tau)/(1+Q2/MV2_NC)/(1+Q2/MV2_NC);
double F2s= F2s_0/(1+tau)/(1+Q2/MV2_NC)/(1+Q2/MV2_NC);
double FAs= delta_s/(1+Q2/Ma2)/(1+Q2/Ma2);


//from faktroy dla protonu i neutronu ^

double F1p_nc = 0.5*(F1p*(1-4*sin_2_theta_W) - F1n - F1s);
double F2p_nc = 0.5*(F2p*(1-4*sin_2_theta_W) - F2n - F2s);
double F1n_nc = 0.5*(F1n*(1-4*sin_2_theta_W) - F1p - F1s);
double F2n_nc = 0.5*(F2n*(1-4*sin_2_theta_W) - F2p - F2s);

double FAn = 0.5*(-Fa + FAs );
double FAp = 0.5*( Fa + FAs );


double AA=0;
double BB=0;
double CC=0;

//czynniki kinematyczne w przekroju proton 
if(nukleon==proton)
{
AA = Q2/M2*( (1+tau)*FAp*FAp  -(1-tau)*F1p_nc*F1p_nc +tau*(1-tau)*F2p_nc*F2p_nc + 4*tau*F1p_nc*F2p_nc);
BB = Q2/M2*FAp*(F1p_nc+F2p_nc);
CC = 0.25*(FAp*FAp + F1p_nc*F1p_nc + tau*F2p_nc*F2p_nc );
}
//czynniki kinematyczne w przekroju neutron
if(nukleon==neutron)
{
AA = Q2/M2*( (1+tau)*FAn*FAn -(1-tau)*F1n_nc*F1n_nc +tau*(1-tau)*F2n_nc*F2n_nc + 4*tau*F1n_nc*F2n_nc);
BB = Q2/M2*FAn*(F1n_nc+F2n_nc);
CC = 0.25*(FAn*FAn + F1n_nc*F1n_nc + tau*F2n_nc*F2n_nc);
}

//w ulkladzie LAB z masa leptonu 0, bo neutrino koncowe

double su = 4*M12*En-Q2;
double suM2 = su / M2;
double ABC = AA + znak * BB * suM2 + CC * suM2 * suM2;
	   
//cout<<"nc="<<(G*G*M2/8/M_PI/En/En)*ABC/cm2<<endl;
//cin.get();

//return M2 * G * G *  / 8 / M_PI / En / En * ABC;

//cout<<"M2="<<M2<<endl;
//cout<<"ABC="<<ABC<<endl;
//cout<<"CR="<<(G*G*M2/8/M_PI/En/En)*(AA + znak* su/M2*BB + su*su/M2/M2*CC)<<endl;
//cin.get();
//return ABC*M*2*GeV2;	       

//cout<<"znak"<<znak<<endl;
return  (G*G*M2/8/M_PI/En/En)*(AA - znak* su/M2*BB + su*su/M2/M2*CC);

/////////////////////////////////////////////////////////////////////////////

}          


//--------------------------------------------------------------------
// Ploty
//--------------------------------------------------------------------
void NC::plot_przekroj_q0(double E,double krok, int flavore, double nucleon_charge, double mag )
     {
   magneton_s=mag;     
   double nu=1-nucleon_charge;
   double pr=nucleon_charge;
   znak =flavore;
   En=E;
   double df;
   
   for(double q0= 0.01*MeV; q0 < 2*En*En/( M + 2*En );q0+=krok )
   {
   df = (pr*przekroj(q0,proton ) + nu*przekroj(q0, neutron));
   cout<< q0 << ' ' << df/((1e-38)*cm2/GeV) <<endl;
   }
     }
void NC::plot_przekroj_q2(double E,double krok, int flavore, double nucleon_charge, double mag )
     {
   magneton_s=mag;     
   znak =flavore;
   En=E;
   double nu=1-nucleon_charge;
   double pr=nucleon_charge;
   for(double q0= 0.01*MeV; q0 < 2*En*En/( M + 2*En );q0+=krok )
   {
   double df= (pr*przekroj(q0, proton)  + nu*przekroj(q0, neutron) ) / (2*(pr +nu )*M);
   cout<< 2*q0*M/(GeV*GeV) << ' ' << df/(1e-38*cm2/GeV/GeV) <<endl;
   }    
    }

void NC::plot_calk(double zakres, double krok, double dokl, int flavore, double nucleon_charge, double mag) 
     {
      magneton_s=mag;

      znak=flavore;
      double pr=nucleon_charge;
      double nu=1-nucleon_charge;
      for( double E =1*MeV; E < zakres; E*=1.05)
      {          
      double sigma= (pr*calkowity(E, proton, dokl) + nu*calkowity(E, neutron , dokl))/(pr+nu);
      cout << En/GeV <<' '<<sigma/((1e-38)*cm2)<<endl;
      }
     }

