#ifndef _NC_H_
#define _NC_H_
#include <iostream>
#include <cmath>
#include "jednostki.h"
#include "calga.h"


const static double MV2=710000*MeV*MeV ;
/////////////////////////////////////////////////////////////////////////////
///               Klasa do wyliczania prdw neutralnych
/////////////////////////////////////////////////////////////////////////////
class NC
{public:

const static double magneton =  4.71   ;
const static double sin2thetaw = 0.232  ;
//const static double M12_2=M12*M12;
const static int proton  = 1;
const static int neutron = -1;  // bylo -1 Czarek
const static int neutrino =1;
const static int antyneutrino = -1;
const static double lp = 1.793;
const static double ln= -1.913;



double En;                       //energia neutrina
int znak;          //neutrino +1 antyneutrino -1
int nukleon;
double magneton_s;      // srednia -0.39 +- 0.70
double ro_s;
double M;
double M2;
double MA;
double MA_2;


//    ----------------------------------------------------------------------
// kind = "+p"  - neutrino proton
// kind = "-p" - antineutrino proton
// kind = "+n"  - neutrino neutron
// kind = "-n" - antineutrino neutron
public:
 
         NC(double E=1*GeV,char nucl='p', char sig='-',double mag=-0.39);
inline   NC& set_energy(double E);
inline   void set_magneton(double mag);
inline   void set_hadron_mass(double mass);
inline   void set_axial_mass(double mass);
         double amplituda(double q0, double qv);
inline   double kinematyka();
inline   double Przekroj(double q0,double qv);
inline   double przekroj(double q0, int nukleon_);
inline   double przekroj_(double q0);
inline   double calkowity(double E, int nukleon_, double dokl );
inline   double sigma(double q2);

void plot_przekroj_q0(double E,double krok, int flavore, double nucleon_charge, double mag );
void plot_przekroj_q2(double E,double krok, int flavore, double nucleon_charge, double mag );
void plot_calk(double zakres, double krok, double dokl, int flavore, double nucleon_charge, double mag);

};  //end of class NC

////////////////////////////////////////////////////////////////////////////////////////////////////
///              I M P L E M E N T A T O N
////////////////////////////////////////////////////////////////////////////////////////////////////


NC& NC::set_energy(double E) 
{	
     En=E;
     return *this;
}


void NC::set_magneton(double mag)
{ 
    magneton_s=mag;   
    ro_s= 0.51 -2.9*magneton_s; 
}

void NC::set_hadron_mass(double mass)
{
}

void NC::set_axial_mass(double mass)
{
    MA=mass;
    MA_2=MA*MA;
}

double NC::kinematyka() 
	  { 
//           return G*G*M/(16*Pi*En*En);
return 1;	  
	  }		   

double NC::Przekroj(double q0,double qv)
          { 	  
//!!!!!!!!!!!!!!!!!!!!!!!!!!!1brakuje nukleon = nukleon_;!!!!!!!!!!!!!!!!!!!!!!!!!1111	   
	  return   amplituda(q0,qv) * kinematyka();
	  }
	  
double NC::przekroj(double q0, int nukleon_)
          { 
	  nukleon = nukleon_;
	  return Przekroj(q0,sqrt(q0*(q0+2*M)));
	  }
double NC::przekroj_(double q0)
          { 
	  return Przekroj(q0,sqrt(q0*(q0+2*M)));
	  }

double NC::calkowity(double E, int nukleon_, double dokl )
         {
	 En = E;
	 nukleon = nukleon_;
	 return calg5(*this,&NC::przekroj_, 0, 2*En*En/(M + 2*En), dokl, 50);
	 }


double NC::sigma(double q2)
	{
	double q0 = -q2/(2*M);
//	return Przekroj(q0,sqrt(q0*(q0+2*M)))/(2*M);
	
	return Przekroj(q0,sqrt(q0*(q0+2*M)));
}


#endif
