#ifndef _scatter_h_
#define _scatter_h_

#include "particle.h"

/// Scatter p1,p2 into p[0],..,p[n-1] uniformly in phase space
int scatter (int n, particle p1, particle p2, 
		    particle p[]);

/// Scatter p1,p2 into p3,p4  isotropically in cms 
/// if f is given returns f(s,q2) for chosen kinematics
double scatter (particle p1,  particle p2, 
	        particle & p3,  particle & p4,
	        double (*f) (double, double) = NULL);  

/// Scatter p1,p2 into p3,p4 occording to distribution 
/// given by f=Ax^3+Bx where x=\cos \theta
int scatterAB (particle p1, particle p2, 
	   particle & p3, particle & p4,
	   double A, double B);
#endif

