//-----------------------------------------------------------------------------------
// File: CRandomGen.h
//
// Desc: Wrapper class for MT19937 random generator
//
// Copyright (c) 2003 Daniel Niewieczerza
//-----------------------------------------------------------------------------------


#ifndef CRANDOMGEN_H
#define CRANDOMGEN_H

#include <iostream>
#include <vector>
#include <time.h>

class CRandomGen
{
	public:
    CRandomGen(unsigned long ul_seed = time(0));
		CRandomGen(std::vector<unsigned long>& ul_seed);
		CRandomGen(std::istream& in);
		
		operator const double() const;
		
		void setSeed(unsigned long ul_seed);
		void saveState(std::ostream& out)const;
		void loadState(std::istream& in);
};

#endif
