#ifndef C_SPECTRAL_FUNC_H
#define C_SPECTRAL_FUNC_H

#include "GConstants.h"
#include "CRandomGen.h"

class CSpectralFunc
{
public:
	virtual ~CSpectralFunc(){};
	
	virtual double evalSF(const double p, const double removE) const = 0;

	virtual double evalMFMomD(const double p) const = 0;
	virtual double evalCorrMomD(const double p) const = 0;
	virtual double evalTotMomD(const double p) const = 0;

	virtual double generateMom() const = 0;

	virtual double get_pBlock() const = 0;
	virtual double get_pMin() const = 0;
	virtual double get_pMax() const = 0;
	virtual double get_eMin() const = 0;
	virtual double get_eMax() const = 0;
	virtual double get_targetAlpha() const = 0;

};

CSpectralFunc* createSF(const TargetElement i_target,
					    const MomDistribs i_momDistrib,
					    const IsospinOfSF i_isospin,
					    CRandomGen& io_rnd);

#endif
