#ifndef FIND_LIMITS_H
#define FIND_LIMITS_H

#include <cmath>

#include "CSFOptions.h"

double FindMinimalOmega(const CSFOptions& opt, 
						const double givenPrecision = 1.0e-5)
{
	const double nuE( opt.get_neutrinoE() );
	const double mLept( opt.get_leptonMass() );


	if (nuE < mLept)
		return nuE - mLept;

	return 0.0;

}


double FindMaximalOmega(const double minimalOmega, 
						const CSFOptions& opt, 
						const double givenPrecision = 1.0e-5)
{
	if (minimalOmega < 0.0)
		return minimalOmega;

	const double nuE( opt.get_neutrinoE() );
	const double mLept( opt.get_leptonMass() );

	return nuE - mLept; 

}


#endif