#include <fstream>

#include "GConstants.h"
#include "CSFOptions.h"
#include "ScatterOnSF.h"


//Event generator for nu-A interactions (EvA)

int main()
{

//------------------------------------------------------------------------------------------------
//All energies are expressed in MeV
//------------------------------------------------------------------------------------------------
//The box below contains all adjustable parameters (except for plot details)
//------------------------------------------------------------------------------------------------

	const TargetElement target(targAr_default);//options are: targC_Ben, targO_Ben, targO_GSF,
									     //			     targCa_GSF, targAr_GSF, targAr_default, targFe_Ben
	const IsospinOfSF isospin(neutron);//options are: neutron, proton
	const MomDistribs momDistrib(md_Ca40_GCo);//options are: md_O16_CdA, md_O16_Ben, md_O16_GCo
											 //				md_Ca40_CdA, md_Ca40_GGo, md_Ca48_GCo

	const ScatteredNeutrinoFlav flav(flav_mu);//options are: flav_mless,  flav_e,  flav_mu,  flav_tau
											//				 flav_amless, flav_ae, flav_amu, flaw_atau
	const FormFactors formFactors(BBBA05FF);//options are: dipoleFF, BBBA05FF, BBA03FF, JLabFF

	const bool switchToEM(false);//electromagnetic or weak interaction
	const bool switchPauliBlocking(true);

	const double neutrinoE(800.0);
	const long   numberOfRepetitions(7200000);//72000000;

	const CSFOptions options(target,
							isospin,
							momDistrib,
							flav,
							formFactors,
							switchToEM,
							switchPauliBlocking,
							neutrinoE,
							numberOfRepetitions);

	
	std::ofstream result1("r1.txt");
		std::ofstream result2("r2.txt");
			std::ofstream result3("r3.txt");
				std::ofstream result4("r4.txt");
					std::ofstream result5("r5.txt");
						std::ofstream result6("r6.txt");
							std::ofstream result7("r7.txt");
								std::ofstream result8("r8.txt");

	ScatterOnSF(options,result1);
		ScatterOnSF(options,result2);
			ScatterOnSF(options,result3);
				ScatterOnSF(options,result4);
					ScatterOnSF(options,result5);
						ScatterOnSF(options,result6);
							ScatterOnSF(options,result7);
								ScatterOnSF(options,result8);
		
	return 0;
}
