#include <fstream>
#include <sstream>
#include "kaskada7.h"
#include "beam.h"
#include "flatnucleus.h"
#include "anynucleus.h"
#include <TFile.h>
#include <TTree.h>
#include "args.h"
#include "nucleusmaker.h"

using namespace std;

int 
main(int argc, const char** argv)
{  
  args a("transparency","transparency.txt","transparency.root");
  a.read(argc,argv);   
  params p;
  p.read(a.input);
  p.read(a.params,"Command line");
  p.list();
  frandom_init(p.random_seed);
  
  nucleus *pnucleus = make_nucleus (p);
  nucleus & nucl = *pnucleus;
  
  event *e=new event;
  TFile *f= new TFile(a.output,"recreate");
  TTree * t2=new TTree("treeout","Tree of events");
  t2->Branch("e","event",&e); ///< tree1 has only one branch (branch of events)

  string name[2] = { "flat", "real" };
   
  stringstream filename;
  filename<<"transparency - "<< p.nucleus_p << "-" << name[p.nucleus_model] << ".dat" << flush;
  ofstream plik (filename.str ().c_str ());

  beam b(p);
  int T, res;
  double przel = 2.0*938.0*pow(10.0, -6.0); //na Q^2
  
for (int energy = 940; energy < 5000; energy+=50)
{ 
  T = 0;

  for(int i=0;i<p.number_of_events;i++)
  {  cout<<"event="<<i<<" begin      \r"; 
     e=new event;
     particle p0=b.shoot();
     p0.r=start_point(pnucleus,p);
     p0.set_energy((double)energy);
     e->out.push_back(p0);
     res = kaskadaevent(p,*e);
     if (res == 0) T++;
     t2->Fill();
     delete e;
     cout<<"event "<<i<<": completed.\r"; 

  }
  
  plik<<(double)(energy-938)*przel<<" "<<(double)T/(double)p.number_of_events<<endl;
  
}  
  
  plik.close();
  f->Write();
  delete t2;
  delete f;
  genrand_write_state(); 
  return 0;
}
